# 参考
# http://labs.eecs.tottori-u.ac.jp/sd/Member/oyamada/OpenCV/html/py_tutorials/py_objdetect/py_face_detection/py_face_detection.html
#import numpy as np
import cv2

face_cascade = cv2.CascadeClassifier('model\haarcascade_frontalface_default.xml')
eye_cascade = cv2.CascadeClassifier('model\haarcascade_eye.xml')

# カメラ映像取得
cap = cv2.VideoCapture(0)

# 初期フレームの読込
end_flag, c_frame = cap.read()
height, width, channels = c_frame.shape

# 変換処理ループ
while end_flag == True:

	img = c_frame
	img_gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
	faces = face_cascade.detectMultiScale(img_gray, minSize=(100, 100))

	for (x,y,w,h) in faces:
		img = cv2.rectangle(img,(x,y),(x+w,y+h),(255,0,0),2)
		roi_gray = img_gray[y:y+h, x:x+w]
		roi_color = img[y:y+h, x:x+w]
		eyes = eye_cascade.detectMultiScale(roi_gray)
		for (ex,ey,ew,eh) in eyes:
			cv2.rectangle(roi_color,(ex,ey),(ex+ew,ey+eh),(0,255,0),2)

	# フレーム表示
	cv2.imshow("Face_Eyes", c_frame)

	# Escキーで終了
	key = cv2.waitKey(1)
	if key == 27:
		break

	# 次のフレーム読み込み
	end_flag, c_frame = cap.read()

# 終了処理
cv2.destroyAllWindows()
cap.release()
