# s を押すとその時の顔を保存
import cv2

face_cascade = cv2.CascadeClassifier('model\haarcascade_frontalface_default.xml')

# カメラ映像取得
cap = cv2.VideoCapture(0)

# 初期フレームの読込
end_flag, c_frame = cap.read()
height, width, channels = c_frame.shape

i=0;
# 変換処理ループ
while end_flag == True:

	img = c_frame
	img_gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
	faces = face_cascade.detectMultiScale(img_gray, minSize=(100, 100))

	for (x,y,w,h) in faces:
		img = cv2.rectangle(img,(x,y),(x+w,y+h),(255,0,0),2)
		roi_gray = img_gray[y:y+h, x:x+w]
		roi_color = img[y:y+h, x:x+w]

	# フレーム表示
	cv2.imshow("Face", c_frame)

	# Escキーで終了
	key = cv2.waitKey(10)
	if key == 27:
		break
	
	if key == ord('s'):
		for x,y,w,h in faces:
			face_cut = img[y+2:y+h, x+2:x+w]
			imgname = "face_cut" + str(i) + ".jpg"
			cv2.imwrite(imgname, face_cut)
			i = i+1
	# 次のフレーム読み込み
	end_flag, c_frame = cap.read()

# 終了処理
cv2.destroyAllWindows()
cap.release()
