import cv2
import numpy as np

cap = cv2.VideoCapture(0)

# 初期フレームの読込
end_flag, c_frame = cap.read()
height, width, channels = c_frame.shape

# ウィンドウの準備
cv2.namedWindow("org")

while end_flag == True:

	# グレースケール変換
	img = c_frame
	img_gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)

	# HoG特徴量 + SVMで人の識別器を作成
	hog = cv2.HOGDescriptor()
	hog.setSVMDetector(cv2.HOGDescriptor_getDefaultPeopleDetector())
	
	#hog = cv2.HOGDescriptor((48,96), (16,16), (8,8), (8,8), 9)
	#hog.setSVMDetector(cv2.HOGDescriptor_getDaimlerPeopleDetector())
	
	hogParams = {'winStride': (8, 8), 'padding': (32, 32), 'scale': 1.05}

	# 作成した識別器で人を検出
	human, r = hog.detectMultiScale(img_gray, **hogParams)

	# 人の領域を赤色の矩形で囲む
	for (x, y, w, h) in human:
		cv2.rectangle(img, (x, y), (x + w, y+h), (0,0,200), 3)

	# フレーム表示
	cv2.imshow("org", c_frame)
	#cv2.imshow("mono", img_gray)

	# Escキーで終了
	key = cv2.waitKey(1)
	if key == 27:
		break

	# 次のフレーム読み込み
	end_flag, c_frame = cap.read()

# 終了処理
cv2.destroyAllWindows()
cap.release()
