import cv2

# VideoCaptureのインスタンスを作成。Webcam複数の場合は、引数で変更 0 -> 1など
cap = cv2.VideoCapture(0)

# モザイク化の関数
def mosaic(src):
    ratio = 0.1
    small = cv2.resize(src, None, fx=ratio, fy=ratio, interpolation=cv2.INTER_NEAREST)
    return cv2.resize(small, src.shape[:2][::-1], interpolation=cv2.INTER_NEAREST)

# エッジ抽出の関数
def edge(src):
    min = 50
    max = 100
    edges = cv2.Canny(src,min,max)
    return edges

while True:
    # VideoCaptureから1フレーム読み込み
    ret, frame = cap.read()
    #copy_frame = frame .copy()
    edframe1 = mosaic(frame)
    edframe2 = edge(frame)

    # 加工なし画像を表示する
    cv2.imshow('Raw Frame', frame)

    # 加工済の画像を表示する
    cv2.imshow('Edited Frame1', edframe1)
    cv2.imshow('Edited Frame2', edframe2)

    # キー入力を1ms待って、k が27（ESC）だったらBreakする
    k = cv2.waitKey(1)
    if k == 27:
        break

# キャプチャをリリースして終了
cap.release()
cv2.destroyAllWindows()
