# pip install opencv-python
# pip install pillow
# pip install tensorflow
# pip install keras
from keras.applications.vgg16 import VGG16, preprocess_input, decode_predictions
from keras.preprocessing import image
import numpy as np
from PIL import Image

file = 'cat1.jpg'

# 画像を224x224にリサイズして読み込む
img = image.load_img(file, target_size=(224, 224))

# VGG16の読み出しと確認
model = VGG16()
model.summary()
print("")

# PIL形式なので、ニューラルネットワーク用にarrayに変換
arr_img = image.img_to_array(img)

# 画像をVGG16モデルの事前学習時と同じ状態に合わせて変換
# preprocess_input関数に渡し、VGG16モデルの事前学習時と同じ状態に変換してくれる
arr_img = preprocess_input(arr_img)

# 3次元テンソル（rows, cols, channels) を 4次元テンソル (samples, rows, cols, channels) に変換
# カラー画像は3次元（3階）テンソル、
input = np.stack([arr_img])
#print(input.shape)

# 予測値を算出
# 予想値は確率が高いTOP10を表示。top=*を変化させると出力も変わる
predict = model.predict(input)
results = decode_predictions(predict, top=10)

# 結果の出力（改行して表示）
# ラベル番号, ラベル, 確率, の順番
print(*results[0],sep='\n')
